# 基于超宽带(UWB)技术的扩展卡尔曼滤波(EKF)算法的 MATLAB 实现仓库

教学性质的：

* GPS IMU经典15维ESKF松组合
* VRU/AHRS姿态融合算法
* 捷联惯导速度位置姿态解算例子
* UWB IMU紧组合融合
* 每个例子自带数据集

运行环境：

* 最低版本: MATLAB R2022a,  必须安装sensor fusion toolbox和navigation tool box

* 需要将`\lib`及其子目录加入MATLAB预设目录， 或者运行一下根目录下的`init.m`

其中UWB+IMU融合和GPS+IMU融合就是经典的15维误差卡尔曼滤波(EKSF)，没有什么论文参考，就是一直用的经典的框架(就是松组合)，见参考部分。

更多内容请访问：

- 知乎：https://www.zhihu.com/people/yang-xi-97-90
- 网站：www.hipnuc.com

参考：

1. 书：捷联惯导算法与组合导航原理 严恭敏及PSINS工具箱官方网站：http://www.psins.org.cn/sy
2. 书：GNSS与惯性及多传感器组合导航系统原理 第二版
3. 书：GPS原理与接收机设计 谢刚
4. 深蓝学院-多传感器融合课程(理论推导及code)
5. 武汉大学牛小骥惯性导航课程(非常好，非常适合入门) https://www.bilibili.com/video/BV1nR4y1E7Yj
6. GPS IMU 松组合 https://kth.instructure.com/files/677996/download?download_frd=1
7. Coursera课程 https://www.coursera.org/learn/state-estimation-localization-self-driving-cars 

推荐的学习路线：

1. 先看武汉大学惯性导航课程(牛小骥老师)，入门非常推荐，也不需要什么教材，做笔记
2. 看严恭敏老师的书籍，视频及code
3. 然后再入组合导航知识
